function varargout=CPUsampleGNF(f,fp,Axis,N,varargin)
%Axis=[-2,2,-2,2]
%N=[400,400];
% CPUsampleGNF(@(z) z.^3-1,@(z) 3*z.^2,[-2,2,-2,2],1000)
% CPUsampleGNF(@(z) z.^3-2*z+2,@(z) 3*z.^2-2,[-2,2,-2,2],1000)
% CPUsampleGNF(@(z) z.^4-2*z+2,@(z) 4*z.^3-2,[-2,2,-2,2],1000)
% CPUsampleGNF(@(z) z.^5-2*z+2,@(z) 5*z.^4-2,[-2,2,-2,2],1000)
% CPUsampleGNF(@(z) z.^5-2*z.^2+2,@(z) 5*z.^4-4*z,[-2,2,-2,2],1000)
% CPUsampleGNF(@(z) -z^.4+z^.3-z^.2+z+1,@(z) -4*z.^3+3*z.^2-2*z+1,[-2,2,-2,2],100)
% CPUsampleGNF(@(z) z.^13-1,@(z) 13*z.^12,[-2,2,-2,2],1500)  % ****
% CPUsampleGNF(@(z) z.^8+15*z.^4-16,@(z) 8*z.^7+60*z.^3,[-2,2,-2,2],1000) % ****
% CPUsampleGNF(@(z) sin(z),@(z) cos(z),[-5,5,-2,2],1000)
% CPUsampleGNF(@(z) z.^6+z.^3-1,@(z) 6*z.^5+3*z.^2,[-2,2,-2,2],1000) % ****
% CPUsampleGNF(@(z) cosh(z)-1,@(z) sinh(z),[-2,2,-2,2],100) % ****
% Suivant n'est pas bon, fp est faux mais resultat joli!
% CPUsampleGNF(@(z) z.^7-z^4-z-1,@(z) 5*z.^4-4*z^3-1,[-2,2,-2,2],400) % ***** avec bcp de divergence
% CPUsampleGNF(@(z) z.^7-z.^3-z-1,@(z) 7*z.^6-3*z.^2-1,[-2,2,-2,2],1000,'cmap1','jet')
% CPUsampleGNF(@(z) (z.^3-1)./(z-3).^2,@(z) 3*z.^2./(z - 3).^2 - 2*(z.^3 - 1)./(z - 3).^3,[-0.1,3.1,-1.2,1.2],2000) % *****
% CPUsampleGNF(@(z) (z.^3-1)./(z-3).^2,@(z) 3*z.^2./(z - 3).^2 - 2*(z.^3 - 1)./(z - 3).^3,[-5,5,-1.5,1.5],[2000,1000]) % *****
% CPUsampleGNF(@(z) (z.^7-1)./(z.^3-1),@(z) 7*z.^6./(z.^3 - 1) - 3*(z.^7 - 1)*z.^2./(z.^3 - 1).^2,[-2,2,-2,2],400) % ***** avec bcp de divergence
% CPUsampleGNF(@(z) (z.^7-1)./(z.^3-1),@(z) 7*z.^6./(z.^3 - 1) - 3*(z.^7 - 1)*z.^2./(z.^3 - 1).^2,[-2,2,-2,2],1000)
% CPUsampleGNF(@(z) (z.^7-1)./(z.^3-1),@(z) 7*z.^6./(z.^3 - 1) - 3*(z.^7 - 1)*z.^2./(z.^3 - 1).^2,[-0.2,0.2,-0.2,0.2],400)
% CPUsampleGNF(@(z) z.^5-complex(0,3)*z.^3-z,@(z) 5*z.^4-complex(0,9)*z.^2-1,[-15,15,-15,15],1500)
% CPUsampleGNF(@(z) sin(z),@(z) cos(z),[pi/2-0.1,pi/2+0.1,-0.1,0.1],1500)
% CPUsampleGNF(@(z) z.^2-1,@(z) 2*z,[-1.5,1.5,-1.5,1.5],1500,'GNFoptions',{'a',complex(1,1)})
% CPUsampleGNF(@(z) z.^2-1,@(z) 2*z,[-0.1,0.1,-0.1,0.1],1500,'GNFoptions',{'a',complex(1,1)})

import Thrust.samples.NewtonFractal.*

p = inputParser;
p.addParamValue('cmap1', 'winter', @ischar );
p.addParamValue('cmap2', 'jet', @ischar );
p.addParamValue('GNFoptions',{},@iscell );
p.parse(varargin{:});
R=p.Results;
if numel(N)==1, N=[N,N];end

x=linspace(Axis(1),Axis(2),N(1));
y=linspace(Axis(3),Axis(4),N(2));
[xGrid,yGrid] = meshgrid( x, y );
z0 = xGrid + 1i*yGrid;
fprintf('Computation on CPU \n');
tstart=tic();
[z,S]=GeneralizedNewtonFractal(f,fp,z0,R.GNFoptions{:});
T(1)=toc(tstart);
fprintf('Newton CPU : %.3f(s)\n',T(1))
[AlphaC,Num]=findZeros(z,S.count,S.itermax,S.tol);
PlotNewtonFractal(x,y,AlphaC,Num,S.count,S.itermax)

figure(1)
disp('Representation of the Newton''s iteration') 
disp('Select starting points... Carriage return to finish!')
[x,y] = ginput();

for i=1:length(x)
  [Z,SS]=GeneralizedNewton(f,fp,complex(x(i),y(i)),R.GNFoptions{:});
  plot(real(Z),imag(Z),'ks-')
end
if nargout==1
  varargout{1}=AlphaC;
end