function PlotNewtonFractal(x,y,AlphaC,Num,count,itermax,varargin)
p = inputParser;
%p.addParamValue('cmap1', 'winter', @ischar );
p.addParamValue('cmap1', 'parula', @ischar );
p.addParamValue('cmap2', 'jet', @ischar );
p.addParamValue('cvgOptions',{},@iscell );
p.parse(varargin{:});
R=p.Results;

if size(AlphaC,1)==1
Alpha=[real(AlphaC);imag(AlphaC)];
else
Alpha=[real(AlphaC)';imag(AlphaC)'];
end
h=figure(1);
clf
set(h,'Position',[0,0, 800, 600])
hold on
cmap=colormap(R.cmap1);
values=unique(Num);
if values(1)==0 % Pas de convergence
  cmap(1,:)=[1,0,0];
end
colormap(cmap)
image(x,y,Num,'CDataMapping','scaled')
title('Basins of attraction of the roots.')
values=unique(Num);
g=@(r) 1-(values(end)-r)/(values(end)-values(1));
colors=Thrust.samples.NewtonFractal.RGB(g(values),colormap);
values=unique(Num);
if isOctave()
  %latex=@(s) sprintf('$%s$',s);
  latex=@(s) s;
else
  latex=@(s) s;
end

k=1;
for i=1:length(values)
  if values(i)==0
    labels{i}='\infty';
  else
    labels{i}=sprintf('\\alpha_{%d}',values(i));
    if ( Alpha(1,k)<= x(end) ) && ( Alpha(1,k)>= x(1) ) && ( Alpha(2,k)<= y(end) ) && ( Alpha(2,k)>= y(1) )
      plot(Alpha(1,k),Alpha(2,k),'.','color','w','Linewidth',1.0,'MarkerFaceColor',colors(i,:),'marker','o','markersize',3)
      text(Alpha(1,k),Alpha(2,k),sprintf('\\alpha_{%d}',k),'color','w','fontsize',14,'fontweight','bold','VerticalAlignment','bottom');
    end
    k=k+1;
  end
end
%labels={'\alpha_1','\alpha_2','\alpha_3','\alpha_4'};
Thrust.samples.NewtonFractal.colorbarIso(colors,values,'labels',labels)
axis equal
axis off

h=figure(2);
clf
set(h,'Position',[0,0, 800, 600])
hold on
image(x,y,count,'CDataMapping','scaled')
colorbar
title('Number of iterations')
cmap=colormap(R.cmap2);
valcount=unique(count);
if valcount(end)==itermax
  caxis([valcount(1),valcount(end-1)])
  cmap(end,:)=[1,1,1];
end
%  values
%  if values(1)==0
%    cmap(1,:)=[1,1,1];
%  end
colormap(cmap)
axis equal
axis off
k=1;
for i=1:length(values)
  if values(i)~=0
    if ( Alpha(1,k)<= x(end) ) && ( Alpha(1,k)>= x(1) ) && ( Alpha(2,k)<= y(end) ) && ( Alpha(2,k)>= y(1) )
      
    plot(Alpha(1,k),Alpha(2,k),'.','color','w','Linewidth',1.0,'MarkerFaceColor',colors(i,:),'marker','o','markersize',3)
    text(Alpha(1,k),Alpha(2,k),sprintf('\\alpha_{%d}',k),'color','w','fontsize',14,'fontweight','bold','VerticalAlignment','bottom');
    end
    k=k+1;
  end
end
