function T=bench(f,fp,box,LN,varargin)
% sample:
%  GNF=@Thrust.samples.NewtonFractal.GeneralizedNewtonFractalVec;
%  LN=[100:100:400;100:100:400]';
%  Thrust.samples.NewtonFractal.bench(@(z) z.^3,@(z) 3*z.^2,[-2,2,-2,2],LN,'GNF',GNF)
  import Thrust.samples.NewtonFractal.*
  p = inputParser;
  p.addParamValue('tol', 1e-8, @isscalar );
  p.addParamValue('itermax', 200, @isscalar );
  p.addParamValue('a', 1, @isscalar );
  p.addParamValue('verbose', 1, @(x) ismember(x,0:1) );
  %p.addParamValue('box', [-1,1,-1,1], @(x) (length(x)==4) );
  %p.addParamValue('N', [100,100], @(x) (length(x)==2) );
  p.addParamValue('GNF',@Thrust.samples.NewtonFractal.GeneralizedNewtonFractal);
  p.parse(varargin{:});
  R=p.Results;
  n=size(LN,1);T=zeros(1,n);
  for i=1:n
    if R.verbose>0,fprintf(' (%d/%d) on %d-by-%d grid : ',i,n,LN(i,:));end
    x=linspace(box(1),box(2),LN(i,1));
    y=linspace(box(3),box(4),LN(i,2));
    [xGrid,yGrid] = meshgrid( x, y );
    z0 = xGrid + 1i*yGrid;
    tstart=tic();
    [z,count]=R.GNF(f,fp,z0,'tol',R.tol,'itermax',R.itermax,'a',R.a);
    T(i)=toc(tstart);
    if R.verbose>0,fprintf('%.3f(s)\n',T(i));end
  end