clear all
close all
import Thrust.samples.NewtonFractal.*

f=@(z) z.^3-1;
df=@(z) 3*z.^2;
tol=1e-10;
itermax=300;
a=1;
box=[-2,2,-2,2];


LN=100:100:400;LN=[LN;LN]';
n=size(LN,1);
Tcpu=zeros(n,2);
fprintf('----------------------------------------\n')
fprintf('Bench of generalized Newton fractals\n')
fprintf('  base : Matlab not vectorized version\n')
fprintf('  vec  : Matlab vectorized version\n')
fprintf('----------------------------------------\n')
fprintf('  f=%s, f''=%s  (matlab datas)\n', ...
        Thrust.tools.strfunhandle(f),Thrust.tools.strfunhandle(df));
fprintf('  tol=%g, itermax=%g, box=[%g,%g,%g,%g]\n',tol,itermax,box);
fprintf('----------------------------------------\n')
fprintf('1) Starting benchmark : \n')
for i=1:n
  fprintf(' (%d/%d) on %d-by-%d grid\n',i,n,LN(i,:));
  z0=complexGrid(box,LN(i,:));
  [~,~,T]=GeneralizedNewtonFractal(f,df,z0,'tol',tol, 'itermax',itermax,'a',a);
  Tcpu(i,1)=T;
  fprintf('   -> base: %.3f(s)\n',T);
  [~,~,T]=GeneralizedNewtonFractalVec(f,df,z0,'tol',tol, 'itermax',itermax,'a',a);
  Tcpu(i,2)=T;
  fprintf('   -> vec : %.3f(s)\n',T);
end
