function [Alpha,Num]=findZeros(z,count,itermax,tol)
% Alpha contains all the unique values with a 
% of tolerance tol of the complex array z
% except those corresponding to z(r,s) where
% count(r,s)==itermax. In this case
% Num(r,s)=0, otherwize Num(r,s)=idx
% with Alpha(idx) == z(r,s) (with tolerance tol).
count=count(:);
zz=z(:);
Num=zeros(length(zz),1);
I=find((count~=itermax) & (~isnan(zz))); % index of points of convergence
[~, ia,ic] = unique(round(zz(I)/(10*tol)));%   (100*tol*complex(1,1))));
Alpha=zz(I(ia));
Num(I)=ic;
Num=reshape(Num,size(z));
