function formalGNF(f,df,box,N,varargin)
% formalGNF(@(z) z.^3-1,@(z) 3*z.^2,[-2,2,-2,2],[100,100])
% formalGNF(@(z) z.^3-1,@(z) 3*z.^2,[-2,2,-2,2],[1000,1000],'GNF',@GeneralizedNewtonFractalVec)
% formalGNF(@(z) z.^3-1,@(z) 3*z.^2,[-2,2,-2,2],[1000,1000],'GNF',@GeneralizedNewtonFractalmThrust)
% formalGNF('z*z*z-1.0','3.0*z*z',[-2,2,-2,2],[1000,1000],'GNF',@GeneralizedNewtonFractalGPU)

  import Thrust.samples.NewtonFractal.*
  p = inputParser;
  p.addParamValue('tol', 1e-8, @isscalar );
  p.addParamValue('itermax', 200, @isscalar );
  p.addParamValue('a', 1, @isscalar );
  p.addParamValue('verbose', 1, @(x) ismember(x,0:1) );
  p.addParamValue('GNF',@Thrust.samples.NewtonFractal.GeneralizedNewtonFractal);
  p.parse(varargin{:});
  R=p.Results;
  
  x=linspace(box(1),box(2),N(1));
  y=linspace(box(3),box(4),N(2));
  [xGrid,yGrid] = meshgrid( x, y );
  z0 = xGrid + 1i*yGrid;
  
  tstart=tic();
  [z,count]=R.GNF(f,df,z0,'tol',R.tol,'itermax',R.itermax,'a',R.a,'verbose',R.verbose);
  T=toc(tstart);
  if R.verbose>0, fprintf(' Computation in %.3f(s)\n',T);end
  [Alpha,Num]=findZeros(z,count,R.itermax,R.tol);
  PlotNewtonFractal(x,y,Alpha,Num,count,R.itermax)
end