import Thrust.samples.NewtonFractal.*
import Thrust.extern.textprogressbar.textprogressbar
tol=1e-12;
itermax=100;
N=2*[150,150];

f=@(z) z.^3-1;
fp=@(z) 3*z.^2;
a=1;

x=linspace(-2,2,N(1));
y=linspace(-2,2,N(2));
[xGrid,yGrid] = meshgrid( x, y );
z0 = xGrid + 1i*yGrid;
fprintf('Computation on CPU (None vectorized version) \n');
fprintf('With a complex grid %d-by-%d \n',N)
%======================= 
tstart=tic();
[z,count]=GeneralizedNewtonFractal(f,fp,z0,'tol',tol,'itermax',itermax);
T(1)=toc(tstart);
fprintf('GeneralizedNewton on complex grid, CPU time : %.3f(s)\n',T(1))
%======================= 

figure(1)
image(x,y,count,'CDataMapping','scaled')                     
colorbar
colormap('jet')
title('Number of iterations')

% Basins of attraction of the roots
[Alpha,Num]=findZeros(z,count,itermax,tol);
fprintf('Finding %d roots to %s==0\n',length(Alpha),Thrust.tools.strfunhandle(f));

figure(2)
image(x,y,Num,'CDataMapping','scaled')
colormap('jet')
title('Basins of attraction of the roots')
