import Thrust.samples.NewtonFractal.*
%  P=Thrust.tools.getCurrentFunctionPath();
%  file=create_funcs('z*z*z*z*z-1.0','5.*z*z*z*z');
%  
%  cudamexfile=[P,'mex_GeneralizedNewtonFractal.cu'];
%  Thrust.compile.mex(cudamexfile,'samepath',true,'verbose',1,'dep',file)


tol=1e-12;
itermax=100;
N=[2000,2000];

f=@(z) z.^3-1;
fp=@(z) 3*z.^2;
a=1;
%a=complex(1,1);

x=linspace(-2,2,N(1));
y=linspace(-2,2,N(2));
[xGrid,yGrid] = meshgrid( x, y );
z0 = xGrid + 1i*yGrid;
z=zeros(size(z0));
count=zeros(size(z0));
fprintf('Computation on CPU (None vectorized version) \n');
%======================= 
tstart=tic();
[z,S]=GeneralizedNewtonFractal(f,fp,z0,'tol',tol,'itermax',itermax);
T(1)=toc(tstart);
%======================= 
count=S.count;

figure(1)
image(x,y,count,'CDataMapping','scaled')                     
colorbar
colormap('jet')
title('Number of iterations')

% Basins of attraction of the roots

fprintf('Newton CPU : %.3f(s)\n',T(1))
[AlphaC,Num]=findZeros(z,count,itermax,tol);

figure(2)
image(x,y,Num,'CDataMapping','scaled')
colormap('jet')
title('Basins of attraction of the roots')
