import Thrust.samples.NewtonFractal.*
%  P=Thrust.tools.getCurrentFunctionPath();
%  file=create_funcs('z*z*z*z*z-1.0','5.*z*z*z*z');
%  
%  cudamexfile=[P,'mex_GeneralizedNewtonFractal.cu'];
%  Thrust.compile.mex(cudamexfile,'samepath',true,'verbose',1,'dep',file)


tol=1e-12;
itermax=100;
N=[500,600];

f=@(z) z.^3-1;
fp=@(z) 3*z.^2;
a=1;
%a=complex(1,1);

x=linspace(-2,2,N(1));
y=linspace(-2,2,N(2));
[xGrid,yGrid] = meshgrid( x, y );
z0 = xGrid + 1i*yGrid;
fprintf('Computation on CPU \n');
tstart=tic();
[z,S]=GeneralizedNewtonFractal(f,fp,z0,'tol',tol,'itermax',itermax,'verbose',0,'a',a);
T(1)=toc(tstart);
fprintf('Newton CPU : %.3f(s)\n',T(1))
[AlphaC,Num]=findZeros(z,S.count,S.itermax,S.tol);
PlotNewtonFractal(x,y,AlphaC,Num,S.count,S.itermax)

figure(1)
disp('Representation of the Newton''s iteration') 
disp('Select starting points... Carriage return to finish!')
[x,y] = ginput();

for i=1:length(x)
  [Z,SS]=GeneralizedNewton(f,fp,complex(x(i),y(i)),'tol',tol,'itermax',itermax,'a',a);
  plot(real(SS.x),imag(SS.x),'ks-')
end