function varargout=gather(varargin)
  p = inputParser; 
  p.addParamValue('verbose', 0, @(x) isscalar(x) & isnumeric(x));
  p.parse(varargin{:});
  verbose=p.Results.verbose;
  name=mfilename();
  if verbose>1, fprintf('TEST : "%s" function\n',name); end
  
  res=test1(verbose);
  %res=res+test2(verbose);
  %res=res+test3(verbose);
  Thrust.valid.tools.printFinalRes(name,res,verbose)
  if nargout==1, varargout{1}=res;end
end

function res=test1(verbose)
  if verbose>1, fprintf(' test 1 : \n'); end
  fail=0;count=0;
  for type=Thrust.types()
    for container=Thrust.containers()
      fail=fail+test1_simple(container{1},type{1},false,verbose);
      count=count+1;
    end
  end
  for type=Thrust.types('type','numerical')
    for container=Thrust.containers()
      fail=fail+test1_simple(container{1},type{1},true,verbose);
      count=count+1;
    end
  end
  res=[fail,count];
  if verbose>1, fprintf(' test 1 : [%d/%d] OK\n',count-fail,count); end
end

function failure=test1_simple(container,type,iscomplex,verbose)  
  failure=0;
  dim=randi(10^5);
  a=Thrust.valid.generate(dim,type,iscomplex);
%    if iscomplex
%      a=Thrust.toCtype(complex(1:dim,1:dim),type).';
%    else
%      a=Thrust.toCtype(1:dim,type).';
%    end
  x=mThrust(a,container);
  startline='  ';
  cmd=sprintf('A=gather(x);');
  if verbose>2
    fprintf('%s%s\n',startline,cmd);
    fprintf('%s %% x is %s\n',startline,prop(x));
  end
  try 
    eval(cmd);
  catch ME
    causeException = MException('MATLAB:mThrust:a','toto');
    ME = addCause(ME,causeException);
    failure=1;
    rethrow(ME)
  end
  z=sum(A~=a);
  if z~=0, failure=1;end
  if (verbose>2)
    S=sprintf('%s %% A is %s',startline,arrayprop(A));
    line=repmat('.',1,70-length(S));
    fprintf('%s%s',S,line);
    if (failure==0), fprintf(' OK\n');else fprintf(' Failed\n');end
  end
end