% @MTHRUST
%
% Files
%   abs           - Absolute value.
%   acos          - Returns the arc cosine of the input argument.
%   acosh         - Returns the nonnegative arc hyperbolic cosine of the input argument.
%   and           - &  Logical AND 
%   asin          - Returns the arc sine of the input argument.
%   asinh         - Returns the arc hyperbolic sine of the input argument. 
%   atan          - Returns the arc tangent of the input argument. 
%   atan2         - Calculate the arc tangent of the ratio of first and second input arguments. 
%   atanh         - Returns the arc hyperbolic tangent of the input argument.
%   cbrt          - Calculate the cube root of the input argument.
%   ceil          - Calculate ceiling of the input argument. 
%   clear         - Clear mThrust objet.
%   conj          - SIN Calculate the sine of the input argument.
%   cos           - Returns the cosine of the input argument.
%   cosh          - Returns the hyperbolic cosine of the input argument.
%   cospi         - Calculate the cosine of the input argument x pi
%   cummax        - Returns the cumulative maximum values of a mThrust vector.
%   cummin        - Returns the cumulative minimum values of a mThrust vector.
%   cumprod       - Returns the cumulative product values of a mThrust vector.
%   cumsum        - Returns the cumulative sum values of a mThrust vector.
%   cyl_bessel_i0 - Calculate the value of the regular modified cylindrical Bessel function of order 0 for the input argument.
%   cyl_bessel_i1 - Calculate the value of the regular modified cylindrical Bessel function of order 1 for the input argument. 
%   debug         - debug Displays some information on an mThrust object
%   disp          - disp display mThrust object
%   duplicate     - COPY copy mThrust object objin values in mThrust object objout. 
%   end           - 
%   eq            - == or EQ  Equal mThrust operator.
%   erf           - Calculate the error function of the input argument.
%   erfc          - Calculate the complementary error function of the input argument.
%   erfcinv       - Calculate the inverse complementary error function of the input argument. 
%   erfcx         - Calculate the scaled complementary error function of the input argument. 
%   erfinv        - Calculate the inverse error function of the input argument. 
%   exp           - Returns the base e exponential of the input argument.
%   exp10         - Calculate the base 10 exponential of the input argument.
%   exp2          - Calculate the base 2 exponential of the input argument. 
%   expm1         - Calculate the base 10 exponential of the input argument, minus 1.
%   fabs          - Calculate the absolute value of the input argument. 
%   find          - sort mThrust
%   floor         - Calculate the largest integer less than or equal to the input argument.
%   gather        - val=mex_gTArrayGatherDevice2Host(obj.handle,obj.type);
%   ge            - >= or GE  Greater than or equal mThrust operator.
%   gt            - > or GT  Greater than mThrust operator.
%   imag          - 
%   iscompatible  - 
%   islogical     - 
%   isnumerical   - 
%   isreal        - 
%   j0            - Calculate the value of the Bessel function of the first kind of order 0 for the input argument.
%   j1            - Calculate the value of the Bessel function of the first kind of order 1 for the input argument.
%   jn            - Calculate the value of the Bessel function of the first kind of order n for the input argument. 
%   ksdensity     - 
%   ldivide       - 
%   le            - <= or LE  Less than or equal mThrust operator.
%   length        - 
%   lgamma        - Calculate the natural logarithm of the absolute value of the gamma function of the input argument.
%   log           - Returns the natural logarithm of the input argument.
%   log10         - Returns the base 10 logarithm of the input argument.
%   log1p         - Calculate the value of  loge( 1 + x ).
%   log2          - Calculate the base 2 logarithm of the input argument. 
%   logb          - Calculate the floating point representation of the exponent of the input argument. 
%   lt            - < or LT  Less than mThrust operator.
%   max           - 
%   mean          - 
%   min           - 
%   minus         - +  mThrust vectors subtraction.
%   modf          - example:
%   mrdivide      - *  mThrust vector division by a scalar.
%   mThrust       - mThrust interface to the CUDA Thrust template library
%   mtimes        - *  mThrust vector multiplication by a scalar.
%   ne            - ~= or NE  Not equal mThrust operator.
%   nearbyint     - Round the input argument to the nearest integer. 
%   normcdf       - Calculate the standard normal cumulative distribution function. 
%   normcdfinv    - Calculate the inverse of the standard normal cumulative distribution function. 
%   not           - ~  Logical NOT 
%   or            - |  Logical OR 
%   partcopy      - COPY copy mThrust object objin values in mThrust object objout. 
%   plot          - 
%   plus          - +  mThrust vectors addition .
%   plusbis       - example
%   power         - .^ or POWER mThrust vector power.
%   prod          - 
%   prop          - 
%   rcbrt         - Calculate reciprocal cube root function.
%   rdivide       - ./  mThrust vector division.
%   real          - 
%   rint          - Round to nearest integer value in floating-point. 
%   round         - Round to nearest integer value in floating-point.
%   rsqrt         - Calculate the reciprocal of the square root of the input argument.
%   sequence      - fills the range [first, last) with a sequence of numbers. 
%   setdiff       - ...
%   sin           - Returns the sine of the input argument.
%   sinh          - Returns the hyperbolic sine of the input argument.
%   sinpi         - Calculate the sine of the input argument x pi
%   size          - 
%   sort          - sort mThrust
%   sqrt          - Returns the square root of the input argument.
%   subsasgn      - 
%   subsref       - see http://fr.mathworks.com/help/matlab/matlab_oop/code-patterns-for-subsref-and-subsasgn-methods.html
%   sum           - 
%   tan           - Returns the tangent of the input argument.
%   tanh          - Returns the hyperbolic tangent of the input argument.
%   tgamma        - Calculate the gamma function of the input argument. 
%   times         - .*  mThrust vector multiplication.
%   trunc         - Truncate input argument to the integral part. 
%   uminus        - 
%   unique        - sort mThrust
%   uplus         - 
%   y0            - Calculate the value of the Bessel function of the second kind of order 0 for the input argument.
%   y1            - Calculate the value of the Bessel function of the second kind of order 1 for the input argument.
