function objout=abs(obj)
% ABS   Absolute value.
%   ABS(X) is the magnitude/complex modulus if X is complex or 
%   the absolute value if X is real of the elements of the 
%   mThrust vector X. The type of X must be 'double'
%   or 'float'.
%
%   Example:
%     dX=mThrust.randn(1000);
%     dY=abs(dX);
%
% Francois Cuvelier 2013-2016
  assert( ismember(obj.type,Thrust.types('type','real')) ,Messages(1));
  objout=mThrust(obj.dim,obj.container,obj.type);
  mex_mThrust_abs(obj,objout);
end