function objout=asinh(obj)
% ASINH Returns the arc hyperbolic sine of the input argument. 

%  Can be used with complex mThrust objects.

% Example:
%   dX=Thrust.linspace(0,2*pi,1000);
%   dY=asinh(dX);

% Francois Cuvelier 2013-2016
  assert( ismember(obj.type,Thrust.types('type','real')) ,Messages(1));
  objout=mThrust(obj.dim,obj.container,obj.type,obj.complex);
  mex_mThrust_asinh(obj,objout);
end