function objout=cospi(obj)
% COSPI Calculate the cosine of the input argument x pi

%  Not to use with complex mThrust objects.

% Example:
%   dX=Thrust.linspace(0,2*pi,1000);
%   dY=cospi(dX);

% Francois Cuvelier 2013-2016
  assert( ~obj.complex ,Messages(0));
  assert( ismember(obj.type,Thrust.types('type','real')) ,Messages(1));
  objout=mThrust(obj);
  mex_mThrust_cospi(obj,objout);
end