function disp(obj,varargin)
% disp display mThrust object
%    disp(A) or A.disp(), display the first five and last five values of the GPU array A.
%
%    Example
%       x = Thrust.sequence(10);
%       disp(x)
%
% Francois Cuvelier 2013-2016
  p = inputParser; 
  p.addParamValue('precision', 6, @(x) isscalar(x) & isnumeric(x));
  p.addParamValue('firstlast', 5, @(x) isscalar(x) & isnumeric(x));
  p.parse(varargin{:});
  R=p.Results;
  %if ~isOctave()  
    drawnow('update'); 
  %else 
  %  fflush(stdout); 
  %end
  
  if obj.dim==0
      fprintf(' mThrust<%s,%s>[%d] : empty\n',obj.container,obj.type,obj.dim);
  else
      mex_mThrust_disp(obj,int32(R.firstlast),int32(R.precision));
  end
end % disp