function objout=lgamma(obj)
% LGAMMA Calculate the natural logarithm of the absolute value of the gamma function of the input argument.

%  Not to use with complex mThrust objects.

% Example:
%   dX=Thrust.linspace(0,2*pi,1000);
%   dY=lgamma(dX);

% Francois Cuvelier 2013-2016
  assert( ~obj.complex ,Messages(0));
  assert( ismember(obj.type,Thrust.types('type','real')) ,Messages(1));
  objout=mThrust(obj);
  mex_mThrust_lgamma(obj,objout);
end