function obj=not(obj1)
% ~  Logical NOT 
%    ~X  or NOT(X) performs the logical NOT of mThrust logical vector A and returns
%    an mThrust logical vector. 
%    The output i-th element is set to logical 1 (true) if A(i)==0 otherwise 
%    is set to logical 1 (false).
%
%    Example
%       x = Thrust.rand(100);
%       z1 = ~(x<0.2);
%       z2 = not(x>0.6);
%
% Francois Cuvelier 2013-2016
  assert(strcmp(obj1.type,'logical') , 'mThrust: object must be logical')
  obj=mThrust(obj1.dim,obj1.container,'logical');
  mex_mThrust_not(obj1,obj);
end