function objout=round(obj)
% ROUND Round to nearest integer value in floating-point.

%  Not to use with complex mThrust objects.

% Example:
%   dX=Thrust.linspace(0,2*pi,1000);
%   dY=round(dX);

% Francois Cuvelier 2013-2016
  assert( ~obj.complex ,Messages(0));
  assert( ismember(obj.type,Thrust.types('type','real')) ,Messages(1));
  objout=mThrust(obj);
  mex_mThrust_round(obj,objout);
end