function objout=sinh(obj)
% SINH Returns the hyperbolic sine of the input argument.

%  Can be used with complex mThrust objects.

% Example:
%   dX=Thrust.linspace(0,2*pi,1000);
%   dY=sinh(dX);

% Francois Cuvelier 2013-2016
  assert( ismember(obj.type,Thrust.types('type','real')) ,Messages(1));
  objout=mThrust(obj.dim,obj.container,obj.type,obj.complex);
  mex_mThrust_sinh(obj,objout);
end