function varargout=sort(obj,varargin)
% sort mThrust
%
% syntax:
%   - sort(A)  A is sorted
%   - C=sort(A); C is a mThrust object (same type,dim,container as A) sorted and A is unchanged
%   - [C,I]=sort(A); C is sorted and A unchanged. I is a mThrust<uint32> 
%     such that C==A(I)
  p = inputParser; 
  p.addParamValue('mode', 'ascend', @(x) ismember(x,{'ascend','descend'}));
  p.parse(varargin{:});
  mode=p.Results.mode;
  if strcmp(mode,'ascend'), Flag=uint32(1);else Flag=uint32(0);end
  
  assert( (nargout<=2),'mThrust:sort bad ouput')
  assert( ~obj.complex)
  switch nargout
    case 0
      mex_mThrust_sort(obj,Flag);
    case 1      
      varargout{1}=duplicate(obj);
      mex_mThrust_sort(varargout{1},Flag);
    case 2
      varargout{1}=duplicate(obj);
      varargout{2}=Thrust.sequence(obj.dim,'container',obj.container,'type','int');
      mex_mThrust_sort_with_index(varargout{1},varargout{2},Flag);
  end
end % sort