% see http://fr.mathworks.com/help/matlab/matlab_oop/code-patterns-for-subsref-and-subsasgn-methods.html
function varargout=subsref(obj,s)
  switch s(1).type
    case '.'
      if length(s) == 1 % Implement obj.PropertyName
        prop = s(1).subs;
        varargout{1}=obj.(prop);
      else
        if nargout==0
          builtin('subsref',obj,s);
        else
          varargout = {builtin('subsref',obj,s)};
        end
      end
    case '()' 
      if length(s) == 1% Implement obj(indices)
        subs=s.subs{:};
        if ( Thrust.ismThrust(subs) ) 
          assert(strcmp(subs.type,'int'),'subs must be an mThrust<int> ');  
          b=mThrust(subs.dim,obj.container,obj.type,obj.complex);
          mex_mThrust_subsref(obj,subs,b);
        elseif ( isnumeric(subs) ) 
          b=mThrust(length(subs),obj.container,obj.type,obj.complex);
          S=mThrust(Thrust.toCtype(subs-1,'int'),obj.container); % take care to convention : matlab index start to one!
          mex_mThrust_subsref(obj,S,b);
        else
          error('incompatible type')
        end
        if (length(subs)==1),b=gather(b);end
        varargout{1}=b;
      else % Use built-in for any other expression
        if nargout==0
          builtin('subsref',obj,s);
        else
          varargout = {builtin('subsref',obj,s)};
        end
    end
end
%  % usage :
%  %
%  %whos
%    index(1)
%    index(2)
%    assert( Thrust.ismThrust(a) ,'a must be a mThrust object');
%    %assert(length(index)==1,'Trouble with index')
%    if strcmp(index(1).type,'.')
%      if length(index)==1
%        eval(['b=a.',index(1).subs,';'])
%        return
%      elseif length(index)==2
%        A=['b=a.',index(1).subs,'(',index(2).subs,');']
%        eval(['b=a.',index(1).subs,'(',index(2).subs{1},');'])
%        return
%      else
%        error('unknow...')
%      end
%    end
%    assert(strcmp(index.type,'()')||strcmp(index.type,'.'),'Only ''()'' or ''.'' authorized in subsref method');
%    s=index.subs{:};
%        
%    b=mThrust(length(s),a.container,a.type);
%    if ( Thrust.ismThrust(s) ) 
%      assert(strcmp(s.type,'int'),'s must be an mThrust<int> ');  
%      mex_mThrust_subsref(a,s,b);
%    elseif ( isnumeric(s) ) 
%      S=mThrust(Thrust.toCtype(s-1,'int'),a.container); % take care to convention : matlab index start to one!
%      mex_mThrust_subsref(a,S,b);
%    else
%      error('incompatible type')
%    end
%    if (length(s)==1)
%      b=gather(b);
%    end
%  end