function objout=y0(obj)
% Y0 Calculate the value of the Bessel function of the second kind of order 0 for the input argument.

%  Not to use with complex mThrust objects.

% Example:
%   dX=Thrust.linspace(0,2*pi,1000);
%   dY=y0(dX);

% Francois Cuvelier 2013-2016
  assert( ~obj.complex ,Messages(0));
  assert( ismember(obj.type,Thrust.types('type','real')) ,Messages(1));
  objout=mThrust(obj);
  mex_mThrust_y0(obj,objout);
end