/* Generic for math function f:T->thrust::complex<T>
 T could be float or double
 
 */

template <typename T,typename Vector> 
void mx_mThrust_funmath_gen(const mxArray *prhs[]){
  Vector &ga = get_object< Vector >(mxGetProperty(prhs[0],0,"handle"));
  T *pa = (T *)mxGetPr(prhs[1]);
  thrust::transform(ga.begin(),ga.end(),ga.begin(), trans_unary_functor<T>(*pa));
}


template  <typename T>
void mx_mThrust_mathfun_gen_type(const mxArray *prhs[]){
  char *container= mxArrayToString(mxGetProperty(prhs[0],0,"container"));
  
  logical *iscomp=(logical *)mxGetPr(mxGetProperty(prhs[0],0,"complex"));
  assert( iscomp );
  
  if (strcmp(container, "device")==0){
    mx_mThrust_funmath_gen<T,thrust::device_vector<thrust::complex<T> > >(prhs); 
  }else if (strcmp(container, "host")==0){
    mx_mThrust_funmath_gen<T,thrust::host_vector<thrust::complex<T> > >(prhs); 
  }else{
    mxFree(container);
    mexErrMsgIdAndTxt(MESS,"Unknow container."); 
  }
  mxFree(container);
}

// prhs[0] : input mThrust object
// prhs[1] : matlab cst
void mexFunction( int nlhs, mxArray *plhs[], int nrhs, const mxArray *prhs[] )     
{
  MEXPRINTF("starting");
  if (nlhs !=0 || nrhs != 2) 
    mexErrMsgTxt("Bad input... To do");
  
  assert( mxIsClass(prhs[0],"mThrust") && mxIsScalar(prhs[1]) );
  
  char *type = mxArrayToString(mxGetProperty(prhs[0],0,"type"));
//     mxArrayToString(mxGetProperty(prhs[1],0,"type"))
//   };
//   assert( strcmp(type[0],type[1])==0 );
  
  if (strcmp(type, "double")==0)
    mx_mThrust_mathfun_gen_type<double>(prhs);
  else if (strcmp(type, "float")==0)
    mx_mThrust_mathfun_gen_type<float>(prhs);
  else if (strcmp(type, "int")==0)
    mx_mThrust_mathfun_gen_type<int>(prhs);
  else if (strcmp(type, "unsigned")==0)
    mx_mThrust_mathfun_gen_type<unsigned>(prhs);
  else{
    //std::cout<< "type: " << type << strcmp(type, "float") << std::endl;
    mxFree(type);
    mexErrMsgIdAndTxt("mThrustToolbox:mathfun_gen","type not implemented.");
  }
  mxFree(type);
  MEXPRINTF("ending");
}