/* Generic for math operator == and != 
   Works with complex 
 */

template  <typename T>
void mx_mThrust_opVec_type( const mxArray *prhs[] ){
  char *container[] = {
    mxArrayToString(mxGetProperty(prhs[0],0,"container")),
    mxArrayToString(mxGetProperty(prhs[1],0,"container")),
    mxArrayToString(mxGetProperty(prhs[2],0,"container"))
  };
  assert( (strcmp(container[0],container[1])==0) );
  bool iscomplex[2]; 
  logical *iscomp=(logical *)mxGetPr(mxGetProperty(prhs[0],0,"complex"));
  iscomplex[0]=*iscomp;
  iscomp=(logical *)mxGetPr(mxGetProperty(prhs[1],0,"complex"));
  iscomplex[1]=*iscomp;
  assert( iscomplex[0] == iscomplex[1] );
  
  if (strcmp(container[0], "host")==0){
    if (iscomplex[0])
      mx_mThrust_opVec<thrust::complex<T>,thrust::host_vector<thrust::complex<T> >, thrust::host_vector<logical> >(prhs);
    else
      mx_mThrust_opVec<T ,thrust::host_vector<T>, thrust::host_vector<logical> >(prhs);
  }else if (strcmp(container[0], "device")==0){
    if (iscomplex[0])
      mx_mThrust_opVec<thrust::complex<T>,thrust::device_vector<thrust::complex<T> >, thrust::device_vector<logical> >(prhs);
    else
      mx_mThrust_opVec<T ,thrust::device_vector<T>, thrust::device_vector<logical> >(prhs);
  }else{
    mxFree(container[0]);mxFree(container[1]);mxFree(container[2]);
    mexErrMsgIdAndTxt("mThrustToolbox:eq","Unknow container."); 
  }
  mxFree(container[0]);mxFree(container[1]);mxFree(container[2]);
}

template  <typename T>
void mx_mThrust_opCst_type( const mxArray *prhs[] ){
  char *container[] = {
    mxArrayToString(mxGetProperty(prhs[0],0,"container")),
    mxArrayToString(mxGetProperty(prhs[2],0,"container"))
  };
  bool iscomplex[2]; 
  logical *iscomp=(logical *)mxGetPr(mxGetProperty(prhs[0],0,"complex"));
  iscomplex[0]=*iscomp;
  iscomplex[1]=mxIsComplex(prhs[1]);
  assert( iscomplex[0] == iscomplex[1] );
  
  if (strcmp(container[0], "host")==0){
    if (iscomplex[0])
      //mx_mThrust_opCst<thrust::complex<T>,thrust::host_vector<thrust::complex<T> >, thrust::host_vector<logical> >(prhs);
      mx_mThrust_opCstComplex<T, thrust::host_vector<thrust::complex<T> >, thrust::host_vector<logical> >(prhs);
    else
      mx_mThrust_opCstReal<T ,thrust::host_vector<T>, thrust::host_vector<logical> >(prhs);
  }else if (strcmp(container[0], "device")==0){
    if (iscomplex[0])
      //mx_mThrust_opCst<thrust::complex<T>,thrust::device_vector<thrust::complex<T> >, thrust::device_vector<logical> >(prhs);
      mx_mThrust_opCstComplex<T,thrust::device_vector<thrust::complex<T> >, thrust::device_vector<logical> >(prhs);
    else
      mx_mThrust_opCstReal<T ,thrust::device_vector<T>, thrust::device_vector<logical> >(prhs);
  }else{
    mxFree(container[0]);mxFree(container[1]);
    mexErrMsgIdAndTxt("mThrustToolbox:eq","Unknow container."); 
  }
  mxFree(container[0]);mxFree(container[1]);
}

void mexFunction( int nlhs, mxArray *plhs[], int nrhs, const mxArray *prhs[] )     
{
  MEXPRINTF("starting");
  if (nlhs !=0 || nrhs != 3) 
    mexErrMsgTxt("Bad input.");
  assert( mxIsClass(prhs[0],"mThrust") && mxIsClass(prhs[2],"mThrust") );
  logical isScalar=false;
  logical ismThrust=mxIsClass(prhs[1],"mThrust");
  if (!ismThrust) isScalar=mxIsScalar(prhs[1]);
  mxAssert( ismThrust || isScalar ,"Input data failed");
  
  char *type =mxArrayToString(mxGetProperty(prhs[0],0,"type"));
  if (strcmp(type, "double")==0){
    if (isScalar) mx_mThrust_opCst_type<double>(prhs);else mx_mThrust_opVec_type<double>(prhs);
  }else if (strcmp(type, "int")==0){
    if (isScalar) mx_mThrust_opCst_type<int>(prhs);else mx_mThrust_opVec_type<int>(prhs);
  }else if (strcmp(type, "float")==0){
    if (isScalar) mx_mThrust_opCst_type<float>(prhs);else mx_mThrust_opVec_type<float>(prhs);
  }else if (strcmp(type, "unsigned")==0){
    if (isScalar) mx_mThrust_opCst_type<unsigned>(prhs);else mx_mThrust_opVec_type<unsigned>(prhs);
  }else if (strcmp(type, "logical")==0){
    if (isScalar) mx_mThrust_opCst_type<logical>(prhs);else mx_mThrust_opVec_type<logical>(prhs);
  }else{
    mxFree(type);
    mexErrMsgIdAndTxt("mThrustToolbox:eq","type not implemented.");
  }
  mxFree(type);
  MEXPRINTF("ending");
}