
template <typename T,typename VectorBool> 
void mx_mThrust_op(const mxArray *prhs[]){
  
  VectorBool &gx = get_object< VectorBool >(mxGetProperty(prhs[0],0,"handle"));
  VectorBool &gy = get_object< VectorBool >(mxGetProperty(prhs[1],0,"handle"));
  assert( gx.size()==gy.size() );
  //thrust::transform(gx.begin(),gx.end(), gy.begin(),gz.begin(), thrust::logical_and<T>());
  thrust::transform(gx.begin(),gx.end(), gy.begin(),gx.begin(), logical_functor);
}
// see functional.h :
// thrust::logical_and, thrust::logical_or, thrust::logical_not


// prhs[0] : input/ouput mThrust object
// prhs[1] : input mThrust object
//    prhs[0] <- prhs[0] OP prhs[1]
void mexFunction( int nlhs, mxArray *plhs[], int nrhs, const mxArray *prhs[] )     
{
  MEXPRINTF("starting");
  if (nlhs !=0 || nrhs != 2) 
    mexErrMsgTxt("Bad input.");
  assert(mxIsClass(prhs[0],"mThrust"));
  assert(mxIsClass(prhs[1],"mThrust"));
  char *container =mxArrayToString(mxGetProperty(prhs[0],0,"container"));
  
  assert( strcmp( mxArrayToString(mxGetProperty(prhs[0],0,"type")), "logical" ) == 0);
  assert( strcmp( mxArrayToString(mxGetProperty(prhs[1],0,"type")), "logical" ) == 0);
  assert( strcmp( container , mxArrayToString(mxGetProperty(prhs[1],0,"container")) ) == 0);
  
  if (strcmp(container, "host")==0){
    mx_mThrust_op<logical,thrust::host_vector<logical> >(prhs);
  }else if (strcmp(container, "device")==0){
    mx_mThrust_op<logical,thrust::device_vector<logical> >(prhs);
  }else{
    mxFree(container);
    mexErrMsgIdAndTxt("mThrustToolbox:set","container not implemented.");
    return;
  }
  mxFree(container);
}