/* Generic subsref or subsasgn codes*/
template  <typename T>
void mx_mThrust_subsgen_type(const mxArray *prhs[]){
  char *container[] = {
    mxArrayToString(mxGetProperty(prhs[0],0,"container")),
    mxArrayToString(mxGetProperty(prhs[1],0,"container")), 
    mxArrayToString(mxGetProperty(prhs[2],0,"container"))
  };
  assert( (strcmp(container[0],container[1])==0) && (strcmp(container[0],container[2])==0) );
  bool iscomplex[3];
  for (int i=0;i<3;i++){
    logical *iscomp=(logical *)mxGetPr(mxGetProperty(prhs[i],0,"complex"));
    iscomplex[i]=*iscomp;
  }
  assert( (iscomplex[0]==iscomplex[2]) && !iscomplex[1] );
  
  if (strcmp(container[0], "device")==0){
    if (iscomplex[0]){
      mx_mThrust_subsgen_device<thrust::complex<T> >(prhs);
    }else 
      mx_mThrust_subsgen_device<T>(prhs); 
  }else if (strcmp(container[0], "host")==0){
    if (iscomplex[0])
      mx_mThrust_subsgen_host<thrust::complex<T> >(prhs);
    else 
      mx_mThrust_subsgen_host<T>(prhs);  
  }else
    mexErrMsgIdAndTxt("mThrustToolbox:subsgen","Unknow container."); 
}

// prhs[0] : handle to input mThrust object
// prhs[1] : handle to index mThrust object (type int)
// prhs[2] : handle to output mThrust object
void mexFunction( int nlhs, mxArray *plhs[], int nrhs, const mxArray *prhs[] )     
{
  MEXPRINTF("starting");
  if (nlhs !=0 || nrhs != 3) 
    mexErrMsgTxt("Bad input... To do");
  
  assert(mxIsClass(prhs[0],"mThrust") && mxIsClass(prhs[1],"mThrust") && mxIsClass(prhs[2],"mThrust"));
  
  char *type[] = {
    mxArrayToString(mxGetProperty(prhs[0],0,"type")),
    mxArrayToString(mxGetProperty(prhs[1],0,"type")), 
    mxArrayToString(mxGetProperty(prhs[2],0,"type"))
  };
  assert( (strcmp(type[0],type[2])==0) && (strcmp(type[1],"int")==0) );
  
  if (strcmp(type[0], "int")==0){
    mx_mThrust_subsgen_type<int>(prhs);
  }else if (strcmp(type[0], "unsigned")==0){
    mx_mThrust_subsgen_type<unsigned>(prhs);
  }else if (strcmp(type[0], "float")==0){
    mx_mThrust_subsgen_type<float>(prhs);
  }else if (strcmp(type[0], "double")==0){
    mx_mThrust_subsgen_type<double>(prhs);
  }else  if (strcmp(type[0], "logical")==0){
    mx_mThrust_subsgen_type<logical>(prhs);
  }else{
    mxFree(type[0]);mxFree(type[1]);mxFree(type[2]);
    mexErrMsgIdAndTxt("mThrustToolbox:subsgen","type not implemented.");
  }
  mxFree(type[0]);mxFree(type[1]);mxFree(type[2]);
  MEXPRINTF("ending");
}