#pragma once

typedef unsigned long MEMORY_TYPE;
//typedef unsigned char logical;
typedef bool logical;
#include <thrust/complex.h>
#include <thrust/device_vector.h>
#include <thrust/host_vector.h>

#define STRLEN_TYPE 32
#define STRLEN_CONTAINER 32

#define __FILENAME__ (strrchr(__FILE__, '/') ? strrchr(__FILE__, '/') + 1 : __FILE__)
#define MEXDEBUG(str) mexPrintf("%s -> %s:%d : %s%s\n",MEXCOLOR,__FILENAME__,__LINE__,str,TEXTCOLOR_END)

#ifdef DEBUG
#define __FILENAME__ (strrchr(__FILE__, '/') ? strrchr(__FILE__, '/') + 1 : __FILE__)
#define MEXPRINTF(str) mexPrintf("%s -> %s:%d : %s%s\n",MEXCOLOR,__FILENAME__,__LINE__,str,TEXTCOLOR_END)
#else
#define MEXPRINTF(str)
#endif

#ifdef VERBOSE
#define __FILENAME__ (strrchr(__FILE__, '/') ? strrchr(__FILE__, '/') + 1 : __FILE__)
#define MEXVERBOSE(str) mexPrintf("%s%s : %s...%s\n",VERBOSECOLOR,str,__FILENAME__,TEXTCOLOR_END);
#else
#define MEXVERBOSE(str)
#endif


#ifdef DEBUG_GPUMEMORY            
#define PRINT_DEBUG(C,T,N,A) printf("%sdebug : %s_vector<%s>[%d] (memory adress: %#lX)%s\n",MEXCOLOR,C,T,N,(MEMORY_TYPE)A,TEXTCOLOR_END);
#else
#define PRINT_DEBUG(C,T,N,A) 
#endif

#ifdef DEBUG_GPUMEMORY            
#define PRINT_DEBUGSTR(S,C,T,N,A) printf("%s%s : %s_vector<%s>[%d] (memory adress: %#lX)%s\n",GPUMEMORYCOLOR,S,C,T,N,(MEMORY_TYPE)A,TEXTCOLOR_END);
// Complex number
#define PRINT_DEBUGSTRC(S,C,T,N,A) printf("%s%s : %s_vector<complex<%s>>[%d] (memory adress: %#lX)%s\n",GPUMEMORYCOLOR,S,C,T,N,(MEMORY_TYPE)A,TEXTCOLOR_END); 
#else
#define PRINT_DEBUGSTR(S,C,T,N,A) 
#define PRINT_DEBUGSTRC(S,C,T,N,A)
#endif

#ifdef OCTAVE
#include "octave_missing.h"
#endif