#include <cstdlib>
#include <stdio.h>

// includes CUDA Runtime
#include <cuda_runtime.h>

int main(void)
{
  int DeviceNumber;
  int devCount;
  
  cudaDeviceProp deviceProp;
  cudaGetDeviceCount(&devCount);
  cudaGetDevice(&DeviceNumber);
  if ((DeviceNumber<0) || (DeviceNumber>=devCount)){
    printf("CUDA device %d not available\n",DeviceNumber);
    return 1;
  }
  
  cudaGetDeviceProperties(&deviceProp, DeviceNumber);
  printf("%d%d\n",deviceProp.major, deviceProp.minor);
  return 0;
}