#include <iostream>
#include <string>
#include "textcolors.h"
#include "ObjectHandle.h"
#include "mThrust.h"
#include "mex.h"

#include <thrust/set_operations.h>

#define MESS "mThrust:setIntersection"

template <typename Vector>
void set_operator(const Vector& A, const Vector& B, Vector& C)
{
  // set_<operator> returns an iterator C_end denoting the end of input
  typename Vector::iterator C_end;
  
  C_end = thrust::set_intersection(A.begin(), A.end(), B.begin(), B.end(), C.begin());
  
  // shrink C to exactly fit output
  C.erase(C_end, C.end());

}

#include "mex_mThrust_math_set_gen.cu"